//17.    .     ,    
unit UnitMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, QControls, Forms,
  QDialogs, StdCtrls, UDrawDomino, UDomino, ExtCtrls, Menus, Controls,
  Dialogs, UAdd;

type
  TForm1 = class(TForm)
    img_start: TImage;
    img_Player1: TImage;
    img_Player2: TImage;
    img_result: TImage;
    Result_lbl: TLabel;
    lbl_Player1: TLabel;
    lbl_Default: TLabel;
    lbl_Player2: TLabel;
    mm1: TMainMenu;
    A1: TMenuItem;
    N1: TMenuItem;
    NNewDefault: TMenuItem;
    NNewPlayer1: TMenuItem;
    NNewPlayer2: TMenuItem;
    mniNDefGen: TMenuItem;
    mniNDefUser: TMenuItem;
    mniNOpen: TMenuItem;
    mniNOpenDefault: TMenuItem;
    mniNOpenPlayer1: TMenuItem;
    mniNOpenPlayer2: TMenuItem;
    mniC1: TMenuItem;
    mniN2: TMenuItem;
    mniN3: TMenuItem;
    mniN4: TMenuItem;
    mniN5: TMenuItem;
    mniN6: TMenuItem;
    mniNSaveDef: TMenuItem;
    mniNSavePlayer1: TMenuItem;
    mniNSavePlayer2: TMenuItem;
    mniNPlayer1Gen: TMenuItem;
    mniNPlayer1User: TMenuItem;
    mniNPlayer2Gen: TMenuItem;
    mniNPlayer2User: TMenuItem;
    mniNSolve: TMenuItem;
    mniNSaveResult: TMenuItem;
    mniNAdd: TMenuItem;
    mniNDefAdd: TMenuItem;
    mniNPlayer1Add: TMenuItem;
    mniNPlayer2Add: TMenuItem;
    mniNClear: TMenuItem;
    mniNDefClear: TMenuItem;
    mniNPlayer1Clear: TMenuItem;
    mniNPlayer2Claer: TMenuItem;
    mniNAllClear: TMenuItem;
    dlgOpen1: TOpenDialog;
    dlgSave1: TSaveDialog;
    mniNDefSaveAs: TMenuItem;
    mniNPlayer1SaveAs: TMenuItem;
    mniNPlayer2SaveAs: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure mniNSolveClick(Sender: TObject);
    procedure mniNDefGenClick(Sender: TObject);
    procedure mniNPlayer1GenClick(Sender: TObject);
    procedure mniNPlayer2GenClick(Sender: TObject);
    procedure mniNDefClearClick(Sender: TObject);
    procedure mniNPlayer1ClearClick(Sender: TObject);
    procedure mniNPlayer2ClaerClick(Sender: TObject);
    procedure mniNAllClearClick(Sender: TObject);
    procedure mniNOpenDefaultClick(Sender: TObject);
    procedure mniNOpenPlayer1Click(Sender: TObject);
    procedure mniNOpenPlayer2Click(Sender: TObject);
    procedure mniNSaveResultClick(Sender: TObject);
    procedure mniNSaveDefClick(Sender: TObject);
    procedure mniNDefSaveAsClick(Sender: TObject);
    procedure mniNPlayer1SaveAsClick(Sender: TObject);
    procedure mniNPlayer2SaveAsClick(Sender: TObject);
    procedure mniNSavePlayer1Click(Sender: TObject);
    procedure mniNSavePlayer2Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure mniNCloseClick;
    procedure mniNDefAddClick(Sender: TObject);
    procedure mniNPlayer1AddClick(Sender: TObject);
    procedure mniNPlayer2AddClick(Sender: TObject);
    procedure mniNDefUserClick(Sender: TObject);
    procedure mniNPlayer1UserClick(Sender: TObject);
    procedure mniNPlayer2UserClick(Sender: TObject);
    procedure mniN4Click(Sender: TObject);
  private
    FDomino:TDrawDomino;
    FPlayer1,FPlayer2,FResult:TDrawDomino;
    procedure MyIdle(Sender: TObject; var Done:Boolean);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  Application.OnIdle:=MyIdle;
  dlgOpen1.InitialDir:=ExtractFilePath(Application.ExeName);
  dlgSave1.InitialDir:=dlgOpen1.InitialDir;
  FDomino:=TDrawDomino.Create(img_start,clRed);
  FResult:=TDrawDomino.Create(img_result, clWhite);
  FPlayer1:=TDrawDomino.Create(img_Player1, clGreen);
  FPlayer2:=TDrawDomino.Create(img_Player2, clBlue);
  DoubleBuffered:=True;
end;

procedure TForm1.MyIdle(Sender: TObject; var Done: Boolean);
begin
  Done:=True;
  mniNDefClear.Enabled := FDomino.Size > 0;
  mniNPlayer1Clear.Enabled := FPlayer1.Size > 0;
  mniNPlayer2Claer.Enabled := FPlayer2.Size > 0;
  mniNClear.Enabled := mniNAllClear.Enabled;
  mniNAllClear.Enabled := (FDomino.Size>0) or (FPlayer2.Size>0) or (FPlayer1.Size>0);
  mniNSolve.Enabled:=(FDomino.Size>0)and(FPlayer2.Size>0)and(FPlayer1.Size>0);
  mniNSaveResult.Enabled := FResult.Size > 0;
  mniNPlayer1Add.Enabled:= FPlayer1.Size < 6;
  mniNPlayer2Add.Enabled:= FPlayer2.Size < 6;
  mniNDefAdd.Enabled:= FDomino.Size < 10;
end;

procedure TForm1.mniNSolveClick(Sender: TObject);
begin
  FDomino.Modified:=False;
  FPlayer1.Modified:=False;
  FPlayer2.Modified:=False;
  FResult.Clear;
  if FDomino.main(FPlayer1,FPlayer2,FResult)
    then
      begin
        FResult.DrawGame(FPlayer1, FPlayer2, FDomino);
      end
    else ShowMessage('  ');
end;

procedure TForm1.mniNDefGenClick(Sender: TObject);
var
  bone:TBone;
  i,n:Integer;
begin
  if (FDomino.Size > 0)
    then mniNDefClear.Click;

  if (FDomino.Size = 0)
    then
      begin
        n:=1;
        if QDialogs.InputQuery('',' - ',n,1,10,1)
          then
            begin
              FResult.Clear;
              Randomize;
              for i:=1 to n do
              repeat
                bone.val1:=Random(7);
                bone.val2:=Random(7);
                bone.Color:=FDomino.Color;
              until FPlayer1.NotInGame(Bone) and FPlayer2.NotInGame(bone) and
                    (FDomino.Add(bone,UDomino.Left) or FDomino.Add(bone,UDomino.Right));
            end;
        FDomino.Draw;
        FPlayer1.Draw;
        FPlayer2.Draw;
      end;

end;

procedure TForm1.mniNPlayer1GenClick(Sender: TObject);
var
  bone:TBone;
  i,n:Integer;
begin
  if (Fplayer1.Size > 0)
    then  mniNPlayer1Clear.Click;

  if(FPlayer1.Size = 0)
    then
      begin
        n:=1;
        if QDialogs.InputQuery('',' - ',n,1,6,1)
          then
            begin
              FResult.Clear;
              Randomize;
              for i:=1 to n do
              repeat
                bone.val1:=Random(7);
                bone.val2:=Random(7);
                bone.Color:=FPlayer1.Color;
              until FDomino.NotInGame(Bone) and FPlayer2.NotInGame(bone) and
                    FPlayer1.Add_disordered(bone);
            end;
        FDomino.Draw;
        FPlayer1.Draw;
        FPlayer2.Draw;
      end;

end;

procedure TForm1.mniNPlayer2GenClick(Sender: TObject);
var
  bone:TBone;
  i,n:Integer;
begin
  if (FPlayer2.Size > 0)
    then mniNPlayer2Claer.Click;

  if (FPlayer2.Size = 0)
    then
      begin
        n:=1;
        if QDialogs.InputQuery('',' - ',n,1,6,1)
          then
            begin
              FResult.Clear;
              Randomize;
              for i:=1 to n do
              repeat
                bone.val1:=Random(7);
                bone.val2:=Random(7);
                bone.Color:=FPlayer2.Color;
              until FDomino.NotInGame(Bone) and FPlayer1.NotInGame(bone) and
                    FPlayer2.Add_disordered(bone);
            end;
        FDomino.Draw;
        FPlayer1.Draw;
        FPlayer2.Draw;
      end;
end;

procedure TForm1.mniNDefClearClick(Sender: TObject);
begin
  case MessageDlg('      ?',mtConfirmation,[mbYes,mbNo], 0) of
      mrYes :
        begin
          FDomino.Clear;
          FResult.Clear;
          FPlayer1.Draw;
          FPlayer2.Draw;
        end;
      mrNo:;
   end;
end;

procedure TForm1.mniNPlayer1ClearClick(Sender: TObject);
begin
  case MessageDlg('       ?',mtConfirmation,[mbYes,mbNo], 0) of
      mrYes :
        begin
          FPlayer1.Clear;
          FDomino.Draw;
          FPlayer2.Draw;
          FResult.Clear;
        end;
      mrNo:;
   end;
end;

procedure TForm1.mniNPlayer2ClaerClick(Sender: TObject);
begin
  case MessageDlg('       ?',mtConfirmation,[mbYes,mbNo], 0) of
     mrYes :
      begin
          FPlayer2.Clear;
          FDomino.Draw;
          FPlayer1.Draw;
          FResult.Clear;
        end;
     mrNo:;
   end;
end;

procedure TForm1.mniNAllClearClick(Sender: TObject);
begin
  case MessageDlg('     ?',mtConfirmation,[mbYes,mbNo], 0) of
    mrYes :
        begin
          FPlayer2.Clear;
          FPlayer1.Clear;
          FDomino.Clear;
          FResult.Clear;
        end;
    mrNo:;
   end;
end;

procedure TForm1.mniNOpenDefaultClick(Sender: TObject);
var
  i:Integer;
  ok:Boolean;
begin
  if dlgOpen1.Execute
    then
      begin
        if FDomino.Size <> 0
          then mniNDefClear.Click;

        if FDomino.Size = 0
          then
            begin
              if FDomino.LoadFromFile(dlgOpen1.FileName,True,clRed,10)
                then
                  begin
                    i:=1;
                    ok:=True;
                    while ok and (i<=FDomino.Size) do
                    begin
                      ok:=FPlayer1.NotInGame(FDomino.Game[i]) and
                          FPlayer2.NotInGame(FDomino.Game[i]);
                      if ok
                        then inc(i);
                    end;
                    if ok
                      then
                        begin
                          FDomino.Draw;
                          FPlayer1.Draw;
                          FPlayer2.Draw;
                        end
                      else
                        begin
                          FDomino.Clear;
                          MessageDlg('  ',mtError,[mbCancel],0);
                        end;
                  end;
            end;
      end;
end;

procedure TForm1.mniNOpenPlayer1Click(Sender: TObject);
var
  i:Integer;
  ok:Boolean;
begin
  if dlgOpen1.Execute
    then
      begin
        if FPlayer1.Size <> 0
          then mniNPlayer1Clear.Click;

        if FPlayer1.Size = 0
          then
            begin
              if FPlayer1.LoadFromFile(dlgOpen1.FileName,False,clGreen,6)
                then
                  begin
                    i:=1;
                    ok:=True;
                    while ok and (i<=FPlayer1.Size) do
                    begin
                      ok:=FPlayer2.NotInGame(FPlayer1.Game[i]) and
                          FDomino.NotInGame(FPlayer1.Game[i]);
                      if ok
                        then inc(i);
                    end;
                    if ok
                      then
                        begin
                          FDomino.Draw;
                          FPlayer1.Draw;
                          FPlayer2.Draw;
                        end
                      else
                        begin
                          FPlayer1.Clear;
                          MessageDlg('  ',mtError,[mbCancel],0);
                        end;
                  end;
            end;
      end;
end;

procedure TForm1.mniNOpenPlayer2Click(Sender: TObject);
var
  i:Integer;
  ok:Boolean;
begin
  if dlgOpen1.Execute
    then
      begin
        if FPlayer2.Size <> 0
          then mniNPlayer1Clear.Click;

        if FPlayer2.Size = 0
          then
            begin
              if FPlayer2.LoadFromFile(dlgOpen1.FileName,False,clBlue,6)
                then
                  begin
                    i:=1;
                    ok:=True;
                    while ok and (i<=FPlayer2.Size) do
                    begin
                      ok:=FPlayer1.NotInGame(FPlayer2.Game[i]) and
                          FDomino.NotInGame(FPlayer2.Game[i]);
                      if ok
                        then inc(i);
                    end;
                    if ok
                      then
                        begin
                          FDomino.Draw;
                          FPlayer1.Draw;
                          FPlayer2.Draw;
                        end
                      else
                        begin
                          FPlayer2.Clear;
                          MessageDlg('  ',mtError,[mbCancel],0);
                        end;
                  end;
            end;
      end;
end;

procedure TForm1.mniNSaveResultClick(Sender: TObject);
begin
  if dlgSave1.Execute
    then FResult.SaveToFile(dlgSave1.FileName);
end;

procedure TForm1.mniNSaveDefClick(Sender: TObject);
begin
  if FDomino.Filename = ''
    then mniNDefSaveAs.Click
    else FDomino.SaveToFile(FDomino.FileName);
end;

procedure TForm1.mniNDefSaveAsClick(Sender: TObject);
begin
  dlgSave1.FileName:=FDomino.Filename;
  if dlgSave1.Execute
    then FDomino.SaveToFile(dlgSave1.FileName);
end;

procedure TForm1.mniNPlayer1SaveAsClick(Sender: TObject);
begin
  dlgSave1.FileName:=FPlayer1.Filename;
  if dlgSave1.Execute
    then FPlayer1.SaveToFile(dlgSave1.FileName);
end;

procedure TForm1.mniNPlayer2SaveAsClick(Sender: TObject);
begin
  dlgSave1.FileName:=FPlayer2.Filename;
  if dlgSave1.Execute
    then FPlayer2.SaveToFile(dlgSave1.FileName);
end;

procedure TForm1.mniNSavePlayer1Click(Sender: TObject);
begin
  if FPlayer1.Filename = ''
    then mniNPlayer1SaveAs.Click
    else FPlayer1.SaveToFile(FDomino.FileName);
end;

procedure TForm1.mniNSavePlayer2Click(Sender: TObject);
begin
  if FPlayer2.Filename = ''
    then mniNPlayer2SaveAs.Click
    else FPlayer2.SaveToFile(FDomino.FileName);
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if (FDomino.Size <> 0) or (FPlayer1.Size <> 0) or (FPlayer2.Size<>0)
    then mniNCloseClick;
  CanClose:=(FDomino.Size = 0) and (FPlayer1.Size = 0) and (FPlayer2.Size = 0);
end;

procedure TForm1.mniNCloseClick;
begin
   case MessageDlg('   ?', mtConfirmation,[mbYes,mbNo],0) of
     mrNo:;
     mrYes:
      begin
        FDomino.Clear;
        FPlayer1.Clear;
        FPlayer2.Clear;
        FResult.Clear;
      end;
   end;
end;

procedure TForm1.mniNDefAddClick(Sender: TObject);
var
  tmpBone:TBone;
begin
  with TAddForm.Create(Self) do
    try
      if ShowModal=mrOK then
      begin
        tmpBone:=Bone;
        tmpBone.Color:=clRed;
        if FPlayer1.NotInGame(tmpBone) and FPlayer2.NotInGame(tmpbone) and
                    (FDomino.Add(tmpbone,UDomino.Left) or FDomino.Add(tmpbone,UDomino.Right))
          then
            begin
              FDomino.Draw;
              FResult.Clear;
            end
          else  MessageDlg('   ',mtError,[mbCancel],0);
      end;

    finally
      Free
    end;
end;

procedure TForm1.mniNPlayer1AddClick(Sender: TObject);
var
  tmpBone:TBone;
begin
  with TAddForm.Create(Self) do
    try
      if ShowModal=mrOK then
      begin
        tmpBone:=Bone;
        tmpBone.Color:=clGreen;
       if FPlayer2.NotInGame(tmpBone) and FDomino.NotInGame(tmpbone) and
                    FPlayer1.Add_disordered(tmpbone)
          then
            begin
              FPlayer1.Draw;
              FResult.Clear;
            end
          else  MessageDlg('   ',mtError,[mbCancel],0);
      end;
    finally
      Free
    end;
end;

procedure TForm1.mniNPlayer2AddClick(Sender: TObject);
var
  tmpBone:TBone;
begin
  with TAddForm.Create(Self) do
    try
      if ShowModal=mrOK then
      begin
        tmpBone:=Bone;
        tmpBone.Color:=clBlue;
        if FPlayer1.NotInGame(tmpBone) and FDomino.NotInGame(tmpbone) and
                    FPlayer2.Add_disordered(tmpbone)
          then
            begin
              FPlayer2.Draw;
              FResult.Clear;
            end
          else  MessageDlg('   ',mtError,[mbCancel],0);
      end;

    finally
      Free
    end;
end;

procedure TForm1.mniNDefUserClick(Sender: TObject);
begin
  if (FDomino.Size > 0)
    then mniNDefClear.Click;
end;

procedure TForm1.mniNPlayer1UserClick(Sender: TObject);
begin
  if (FPlayer1.Size > 0)
    then mniNPlayer1Clear.Click;
end;

procedure TForm1.mniNPlayer2UserClick(Sender: TObject);
begin
  if (FPlayer2.Size > 0)
    then mniNPlayer2Claer.Click;
end;

procedure TForm1.mniN4Click(Sender: TObject);
begin
  Close;
  FreeAndNil(FDomino);
  FreeAndNil(FPlayer1);
  FreeAndNil(FPlayer2);
  FreeAndNil(FResult);
end;

end.
